package sun.rmi.transport;

import java.util.ArrayList;
import java.rmi.server.UID;
import sun.misc.ObjectInputFilter;
import java.rmi.UnmarshalException;
import sun.rmi.transport.tcp.TCPConnection;
import java.rmi.dgc.Lease;
import java.io.ObjectOutput;
import java.rmi.UnexpectedException;
import java.rmi.RemoteException;
import java.io.IOException;
import java.rmi.MarshalException;
import java.rmi.dgc.VMID;
import java.rmi.server.ObjID;
import java.rmi.server.RemoteRef;
import java.rmi.server.Operation;
import java.rmi.dgc.DGC;
import java.rmi.server.RemoteStub;

public final class DGCImpl_Stub extends RemoteStub implements DGC
{
    private static final Operation[] operations;
    private static final long interfaceHash = -669196253586618813L;
    private static int DGCCLIENT_MAX_DEPTH;
    private static int DGCCLIENT_MAX_ARRAY_SIZE;
    
    public DGCImpl_Stub() {
    }
    
    public DGCImpl_Stub(RemoteRef ref) {
        super(ref);
    }
    
    @Override
    public void clean(ObjID[] array, long n, VMID vmid, boolean b) throws RemoteException {
        try {
            StreamRemoteCall streamRemoteCall = (StreamRemoteCall)this.ref.newCall(this, DGCImpl_Stub.operations, 0, -669196253586618813L);
            streamRemoteCall.setObjectInputFilter((sun.misc.ObjectInputFilter<sun.rmi.transport.DGCImpl_Stub,sun.misc.ObjectInputFilter.Status>)DGCImpl_Stub::leaseFilter);
            try {
                ObjectOutput outputStream = streamRemoteCall.getOutputStream();
                outputStream.writeObject(array);
                outputStream.writeLong(n);
                outputStream.writeObject(vmid);
                outputStream.writeBoolean(b);
            }
            catch (IOException ex) {
                throw new MarshalException("error marshalling arguments", ex);
            }
            this.ref.invoke(streamRemoteCall);
            this.ref.done(streamRemoteCall);
        }
        catch (RuntimeException ex2) {
            throw ex2;
        }
        catch (RemoteException ex3) {
            throw ex3;
        }
        catch (Exception ex4) {
            throw new UnexpectedException("undeclared checked exception", ex4);
        }
    }
    
    @Override
    public Lease dirty(ObjID[] array, long n, Lease lease) throws RemoteException {
        try {
            StreamRemoteCall streamRemoteCall = (StreamRemoteCall)this.ref.newCall(this, DGCImpl_Stub.operations, 1, -669196253586618813L);
            streamRemoteCall.setObjectInputFilter((sun.misc.ObjectInputFilter<sun.rmi.transport.DGCImpl_Stub,sun.misc.ObjectInputFilter.Status>)DGCImpl_Stub::leaseFilter);
            try {
                ObjectOutput outputStream = streamRemoteCall.getOutputStream();
                outputStream.writeObject(array);
                outputStream.writeLong(n);
                outputStream.writeObject(lease);
            }
            catch (IOException ex) {
                throw new MarshalException("error marshalling arguments", ex);
            }
            this.ref.invoke(streamRemoteCall);
            Connection connection = streamRemoteCall.getConnection();
            ObjectOutput outputStream;
            try {
                outputStream = (Lease)streamRemoteCall.getInputStream().readObject();
            }
            catch (ClassCastException | IOException | ClassNotFoundException ex2) {
                if ((connection instanceof TCPConnection)) {
                    ((TCPConnection)connection).getChannel().free(connection, false);
                }
                streamRemoteCall.discardPendingRefs();
                throw new UnmarshalException("error unmarshalling return", ex2);
            }
            finally {
                this.ref.done(streamRemoteCall);
            }
            return outputStream;
        }
        catch (RuntimeException ex3) {
            throw ex3;
        }
        catch (RemoteException ex4) {
            throw ex4;
        }
        catch (Exception ex5) {
            throw new UnexpectedException("undeclared checked exception", ex5);
        }
    }
    
    private static ObjectInputFilter.Status leaseFilter(ObjectInputFilter.FilterInfo filterInfo) {
        if (filterInfo.depth() > (long)DGCImpl_Stub.DGCCLIENT_MAX_DEPTH) {
            return ObjectInputFilter.Status.REJECTED;
        }
        Class<Object> clazz = filterInfo.serialClass();
        if (clazz != null) {
            while (clazz.isArray()) {
                if (filterInfo.arrayLength() >= 0L && filterInfo.arrayLength() > (long)DGCImpl_Stub.DGCCLIENT_MAX_ARRAY_SIZE) {
                    return ObjectInputFilter.Status.REJECTED;
                }
                clazz = clazz.getComponentType();
            }
            if (clazz.isPrimitive()) {
                return ObjectInputFilter.Status.ALLOWED;
            }
            return (clazz == UID.class || clazz == VMID.class || clazz == Lease.class || (clazz.getPackage() != null && Throwable.class.isAssignableFrom(clazz) && ("java.lang".equals(clazz.getPackage().getName()) || "java.rmi".equals(clazz.getPackage().getName()))) || clazz == StackTraceElement.class || clazz == ArrayList.class || clazz == Object.class || clazz.getName().equals("java.util.Collections$UnmodifiableList") || clazz.getName().equals("java.util.Collections$UnmodifiableCollection") || clazz.getName().equals("java.util.Collections$UnmodifiableRandomAccessList") || clazz.getName().equals("java.util.Collections$EmptyList")) ? ObjectInputFilter.Status.ALLOWED : ObjectInputFilter.Status.REJECTED;
        }
        else {
            return ObjectInputFilter.Status.UNDECIDED;
        }
    }
    
    static {
        operations = new Operation[] { new Operation("void clean(java.rmi.server.ObjID[], long, java.rmi.dgc.VMID, boolean)"), new Operation("java.rmi.dgc.Lease dirty(java.rmi.server.ObjID[], long, java.rmi.dgc.Lease)") };
        DGCImpl_Stub.DGCCLIENT_MAX_DEPTH = 6;
        DGCImpl_Stub.DGCCLIENT_MAX_ARRAY_SIZE = 10000;
    }
}
